scala.collection.parallel.immutable.ParMap

# WithDefault

###
Related Doc: package ParMap

#### class WithDefault[K, +V] extends ParMap.WithDefault[K, V] with ParMap[K, V]

Source
  ParMap.scala

Linear Supertypes
ParMap[K, V], ParIterable[(K, V)], Immutable, ParMap.WithDefault[K, V], parallel.ParMap[K, V], ParMapLike[K, V, ParMap[K, V], immutable.Map[K, V]], parallel.ParIterable[(K, V)], ParIterableLike[(K, V), ParMap[K, V], immutable.Map[K, V]], Parallel, CustomParallelizable[(K, V), ParMap[K, V]], GenericParMapTemplate[K, V, ParMap], GenericParTemplate[(K, V), ParIterable], HasNewCombiner[(K, V), ParMap[K, V]], GenMap[K, V], GenIterable[(K, V)], GenTraversable[(K, V)], GenericTraversableTemplate[(K, V), ParIterable], HasNewBuilder[(K, V), scala.collection.parallel.immutable.ParIterable[(K, V)] @scala.annotation.unchecked.uncheckedVariance], GenMapLike[K, V, ParMap[K, V]], Equals, GenIterableLike[(K, V), ParMap[K, V]], GenTraversableLike[(K, V), ParMap[K, V]], Parallelizable[(K, V), ParMap[K, V]], GenTraversableOnce[(K, V)], AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. WithDefault
2. ParMap
3. ParIterable
4. Immutable
5. WithDefault
6. ParMap
7. ParMapLike
8. ParIterable
9. ParIterableLike
10. Parallel
11. CustomParallelizable
12. GenericParMapTemplate
13. GenericParTemplate
14. HasNewCombiner
15. GenMap
16. GenIterable
17. GenTraversable
18. GenericTraversableTemplate
19. HasNewBuilder
20. GenMapLike
21. Equals
22. GenIterableLike
23. GenTraversableLike
24. Parallelizable
25. GenTraversableOnce
26. AnyRef
27. Any

Implicitly

1. by CollectionsHaveToParArray
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new WithDefault(underlying: ParMap[K, V], d: (K) ⇒ V)

### Type Members

1. #### trait Accessor[R, Tp] extends StrictSplitterCheckTask[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

   Standard accessor task that iterates over the elements of the collection.

   R

     type of the result of this method (`R` for result).

   Tp

     the representation type of the task at hand.

   Attributes
     protected
   Definition Classes
     ParIterableLike

2. #### class Aggregate[S] extends Accessor[S, Aggregate[S]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

3. #### trait BuilderOps[Elem, To] extends AnyRef

   Definition Classes
     ParIterableLike

4. #### class Collect[S, That] extends Transformer[Combiner[S, That], Collect[S, That]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

5. #### abstract class Composite[FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

6. #### class Copy[U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]

   Attributes
     protected
   Definition Classes
     ParIterableLike

7. #### class CopyToArray[U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

8. #### class Count extends Accessor[Int, Count]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

9. #### class CreateScanTree[U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

10. #### class DefaultKeySet extends ParSet[K]

    Attributes
      protected
    Definition Classes
      ParMapLike

11. #### class DefaultValuesIterable extends ParIterable[V]

    Attributes
      protected
    Definition Classes
      ParMapLike

12. #### class Drop[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

13. #### class Exists extends Accessor[Boolean, Exists]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

14. #### class Filter[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

15. #### class FilterNot[U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

16. #### class Find[U >: T] extends Accessor[Option[U], Find[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

17. #### class FlatMap[S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

18. #### class Fold[U >: T] extends Accessor[U, Fold[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

19. #### class Forall extends Accessor[Boolean, Forall]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

20. #### class Foreach[S] extends Accessor[Unit, Foreach[S]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

21. #### class FromScanTree[U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

22. #### class GroupBy[K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

23. #### class Map[S, That] extends Transformer[Combiner[S, That], Map[S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

24. #### class Max[U >: T] extends Accessor[Option[U], Max[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

25. #### class Min[U >: T] extends Accessor[Option[U], Min[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

26. #### trait NonDivisible[R] extends NonDivisibleTask[R, NonDivisible[R]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

27. #### trait NonDivisibleTask[R, Tp] extends StrictSplitterCheckTask[R, Tp]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

28. #### abstract class ParComposite[FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

    Performs two tasks in parallel, and waits for both to finish.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

29. #### class Partition[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

30. #### class Product[U >: T] extends Accessor[U, Product[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

31. #### class Reduce[U >: T] extends Accessor[Option[U], Reduce[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

32. #### abstract class ResultMapping[R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

33. #### type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]

    Definition Classes
      ParIterableLike

34. #### case class ScanLeaf[U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with scala.Product with Serializable

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

35. #### case class ScanNode[U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with scala.Product with Serializable

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

36. #### trait ScanTree[U >: T] extends AnyRef

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

37. #### abstract class SeqComposite[FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

    Sequentially performs one task after another.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

38. #### trait SignallingOps[PI <: DelegatedSignalling] extends AnyRef

    Definition Classes
      ParIterableLike

39. #### class Slice[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

40. #### class Span[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

41. #### class SplitAt[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

42. #### trait StrictSplitterCheckTask[R, Tp] extends Task[R, Tp]

    Attributes
      protected
    Definition Classes
      ParIterableLike

43. #### class Sum[U >: T] extends Accessor[U, Sum[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

44. #### class Take[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

45. #### class TakeWhile[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

46. #### trait TaskOps[R, Tp] extends AnyRef

    Definition Classes
      ParIterableLike

47. #### class ToParCollection[U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

48. #### class ToParMap[K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

49. #### trait Transformer[R, Tp] extends Accessor[R, Tp]

    Attributes
      protected
    Definition Classes
      ParIterableLike

50. #### class Zip[U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

51. #### class ZipAll[U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +[U >: V](kv: (K, U)): WithDefault[K, U]

   Definition Classes
     WithDefault → ParMap → ParMap → GenMapLike

4. #### def ++[B](that: GenTraversableOnce[B]): ParMap[B]

   [use case] Returns a new parallel map containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new parallel map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the parallel map is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = List(1)
       a: List[Int] = List(1)

       scala> val b = List(2)
       b: List[Int] = List(2)

       scala> val c = a ++ b
       c: List[Int] = List(1, 2)

       scala> val d = List('a')
       d: List[Char] = List(a)

       scala> val e = c ++ d
       e: List[AnyVal] = List(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new parallel map which contains all elements of this parallel map followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike
   Full Signature

   #### def ++[U >: (K, V), That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[ParMap[K, V], U, That]): That

5. #### def -(key: K): WithDefault[K, V]

   Definition Classes
     WithDefault → GenMapLike

6. #### def ->[B](y: B): (WithDefault[K, V], B)

   Implicit information
     This member is added by an implicit conversion from WithDefault[K, V] to ArrowAssoc[WithDefault[K, V]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

7. #### def /:[S](z: S)(op: (S, (K, V)) ⇒ S): S

   Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

   Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this parallel iterable, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this parallel iterable.

   Definition Classes
     ParIterableLike → GenTraversableOnce

8. #### def :\[S](z: S)(op: ((K, V), S) ⇒ S): S

   Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

   Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this parallel iterable, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this parallel iterable.

   Definition Classes
     ParIterableLike → GenTraversableOnce

9. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### def aggregate[S](z: ⇒ S)(seqop: (S, (K, V)) ⇒ S, combop: (S, S) ⇒ S): S

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the set, while `combop` would concatenate two sets from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    S

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      ParIterableLike → GenTraversableOnce

11. #### def apply(key: K): V

    Definition Classes
      ParMapLike → GenMapLike

12. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

13. #### def bf2seq[S, That](bf: CanBuildFrom[ParMap[K, V], S, That]): CanBuildFrom[immutable.Map[K, V], S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

14. #### implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]

    Attributes
      protected
    Definition Classes
      ParIterableLike

15. #### def canEqual(other: Any): Boolean

    Definition Classes
      ParIterableLike

16. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

17. #### def collect[B](pf: PartialFunction[A, B]): ParMap[B]

    [use case] Builds a new collection by applying a partial function to all elements of this parallel map

    [use case]

    Builds a new collection by applying a partial function to all elements of this parallel map

    on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the parallel map .

    returns

      a new parallel map resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def collect[S, That](pf: PartialFunction[(K, V), S])(implicit bf: CanBuildFrom[ParMap[K, V], S, That]): That

18. #### def combinerFactory[S, That](cbf: () ⇒ Combiner[S, That]): CombinerFactory[S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

19. #### def combinerFactory: CombinerFactory[(K, V), ParMap[K, V]]

    Creates a combiner factory.

    Creates a combiner factory. Each combiner factory instance is used once per invocation of a parallel transformer method for a single collection.

    The default combiner factory creates a new combiner every time it is requested, unless the combiner is thread-safe as indicated by its `canBeShared` method. In this case, the method returns a factory which returns the same combiner each time. This is typically done for concurrent parallel collections, the combiners of which allow thread safe access.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

20. #### def companion: GenericCompanion[ParIterable] with GenericParCompanion[ParIterable]

    The factory companion object that builds instances of class `ParIterable`.

    The factory companion object that builds instances of class `ParIterable`. (or its `Iterable` superclass where class `ParIterable` is not a `Seq`.)

    Definition Classes
      ParIterable → ParIterable → GenericParTemplate → GenIterable → GenTraversable → GenericTraversableTemplate

21. #### def contains(key: K): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      ParMapLike → GenMapLike

22. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with at most `len` elements of this parallel map , starting at position `start`. Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int, len: Int): Unit

23. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with values of this parallel map , beginning at index `start`. Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int): Unit

24. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies the elements of this parallel map to an array.

    [use case]

    Copies the elements of this parallel map to an array. Fills the given array `xs` with values of this parallel map . Copying will stop once either the end of the current parallel map is reached, or the end of the target array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def copyToArray[U >: (K, V)](xs: Array[U]): Unit

25. #### def count(p: ((K, V)) ⇒ Boolean): Int

    Counts the number of elements in the parallel iterable which satisfy a predicate.

    Counts the number of elements in the parallel iterable which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

26. #### def debugBuffer: ArrayBuffer[String]

    Definition Classes
      ParIterableLike

27. #### def default(key: K): V

    Definition Classes
      WithDefault → ParMapLike → GenMapLike

28. #### implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]

    Attributes
      protected
    Definition Classes
      ParIterableLike

29. #### def drop(n: Int): ParMap[K, V]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this parallel iterable.

    returns

      a parallel iterable consisting of all elements of this parallel iterable except the first `n` ones, or else the empty parallel iterable, if this parallel iterable has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

30. #### def dropWhile(pred: ((K, V)) ⇒ Boolean): ParMap[K, V]

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this parallel iterable that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

31. #### def empty: WithDefault[K, V]

    Definition Classes
      WithDefault → ParMap → ParMap → ParMapLike

32. #### def ensuring(cond: (WithDefault[K, V]) ⇒ Boolean, msg: ⇒ Any): WithDefault[K, V]

    Implicit information
      This member is added by an implicit conversion from WithDefault[K, V] to Ensuring[WithDefault[K, V]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### def ensuring(cond: (WithDefault[K, V]) ⇒ Boolean): WithDefault[K, V]

    Implicit information
      This member is added by an implicit conversion from WithDefault[K, V] to Ensuring[WithDefault[K, V]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: Boolean, msg: ⇒ Any): WithDefault[K, V]

    Implicit information
      This member is added by an implicit conversion from WithDefault[K, V] to Ensuring[WithDefault[K, V]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### def ensuring(cond: Boolean): WithDefault[K, V]

    Implicit information
      This member is added by an implicit conversion from WithDefault[K, V] to Ensuring[WithDefault[K, V]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

36. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### def equals(that: Any): Boolean

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any

38. #### def exists(p: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this parallel iterable.

    Tests whether a predicate holds for some element of this parallel iterable.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      a predicate used to test elements

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

39. #### def filter(pred: ((K, V)) ⇒ Boolean): ParMap[K, V]

    Selects all elements of this parallel iterable which satisfy a predicate.

    Selects all elements of this parallel iterable which satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new parallel iterable consisting of all elements of this parallel iterable that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

40. #### def filterKeys(p: (K) ⇒ Boolean): parallel.ParMap[K, V]

    Filters this map by retaining only keys satisfying a predicate.

    Filters this map by retaining only keys satisfying a predicate.

    p

      the predicate used to test keys

    returns

      an immutable map consisting only of those key value pairs of this map where the key satisfies the predicate `p`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      ParMapLike → GenMapLike

41. #### def filterNot(pred: ((K, V)) ⇒ Boolean): ParMap[K, V]

    Selects all elements of this parallel iterable which do not satisfy a predicate.

    Selects all elements of this parallel iterable which do not satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new parallel iterable consisting of all elements of this parallel iterable that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

42. #### def find(p: ((K, V)) ⇒ Boolean): Option[(K, V)]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      predicate used to test the elements

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

43. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): ParMap[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel map

    [use case]

    Builds a new collection by applying a function to all elements of this parallel map

    and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of parallel map . This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new parallel map resulting from applying the given collection-valued function `f` to each element of this parallel map and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def flatMap[S, That](f: ((K, V)) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[ParMap[K, V], S, That]): That

44. #### def flatten[B]: ParMap[B]

    [use case] Converts this parallel map of traversable collections into a parallel map formed by the elements of these traversable collections.

    [use case]

    Converts this parallel map of traversable collections into a parallel map formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of parallel map . For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new parallel map resulting from concatenating all element parallel map s.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: ((K, V)) ⇒ GenTraversableOnce[B]): ParIterable[B]

45. #### def fold[U >: (K, V)](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce

46. #### def foldLeft[S](z: S)(op: (S, (K, V)) ⇒ S): S

    Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

    Applies a binary operator to a start value and all elements of this parallel iterable, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this parallel iterable. Returns `z` if this parallel iterable is empty.

    Definition Classes
      ParIterableLike → GenTraversableOnce

47. #### def foldRight[S](z: S)(op: ((K, V), S) ⇒ S): S

    Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

    Applies a binary operator to all elements of this parallel iterable and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this parallel iterable. Returns `z` if this parallel iterable is empty.

    Definition Classes
      ParIterableLike → GenTraversableOnce

48. #### def forall(p: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this parallel iterable.

    Tests whether a predicate holds for all elements of this parallel iterable.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    p

      a predicate used to test elements

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

49. #### def foreach[U](f: ((K, V)) ⇒ U): Unit

    Applies a function `f` to all the elements of parallel iterable in an undefined order.

    Applies a function `f` to all the elements of parallel iterable in an undefined order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

50. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from WithDefault[K, V] to StringFormat[WithDefault[K, V]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

51. #### def genericBuilder[B]: Combiner[B, ParIterable[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericParTemplate → GenericTraversableTemplate

52. #### def genericCombiner[B]: Combiner[B, ParIterable[B]]

    Definition Classes
      GenericParTemplate

53. #### def genericMapCombiner[P, Q]: Combiner[(P, Q), ParMap[P, Q]]

    Definition Classes
      GenericParMapTemplate

54. #### def get(key: K): Option[V]

    Definition Classes
      WithDefault → GenMapLike

55. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

56. #### def getOrElse(key: A, default: ⇒ B): B

    [use case] Returns the value associated with a key, or a default value if the key is not contained in the map.

    [use case]

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

    Definition Classes
      ParMapLike → GenMapLike
    Full Signature

    #### def getOrElse[U >: V](key: K, default: ⇒ U): U

57. #### def groupBy[K](f: ((K, V)) ⇒ K): ParMap[K, ParMap[K, V]]

    Partitions this parallel iterable into a map of parallel iterables according to some discriminator function.

    Partitions this parallel iterable into a map of parallel iterables according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new parallel iterable.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to parallel iterables such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a parallel iterable of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike

58. #### def hasDefiniteSize: Boolean

    Tests whether this parallel iterable is known to have a finite size.

    Tests whether this parallel iterable is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

    Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

59. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any

60. #### def head: (K, V)

    Selects the first element of this parallel iterable.

    Selects the first element of this parallel iterable.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the parallel iterable is empty.

61. #### def headOption: Option[(K, V)]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this parallel iterable if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike

62. #### def init: ParMap[K, V]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a parallel iterable consisting of all elements of this parallel iterable except the last one.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the parallel iterable is empty.

63. #### def initTaskSupport(): Unit

    Attributes
      protected
    Definition Classes
      ParIterableLike

64. #### def isDefinedAt(key: K): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key. This method, which implements an abstract method of trait `PartialFunction`, is equivalent to `contains`.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      ParMapLike → GenMapLike

65. #### def isEmpty: Boolean

    Tests whether the parallel iterable is empty.

    Tests whether the parallel iterable is empty.

    Note: Implementations in subclasses that are not repeatedly traversable must take care not to consume any elements when `isEmpty` is called.

    returns

      `true` if the parallel iterable contains no elements, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

66. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

67. #### def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

    Definition Classes
      ParIterableLike

68. #### final def isTraversableAgain: Boolean

    Tests whether this parallel iterable can be repeatedly traversed.

    Tests whether this parallel iterable can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

69. #### def iterator: Splitter[(K, V)]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParIterableLike → GenIterableLike

70. #### def keySet: parallel.ParSet[K]

    Definition Classes
      ParMapLike → GenMapLike

71. #### def keys: parallel.ParIterable[K]

    Collects all keys of this map in an iterable collection.

    Collects all keys of this map in an iterable collection.

    returns

      the keys of this map as an iterable.

    Definition Classes
      ParMapLike → GenMapLike

72. #### def keysIterator: IterableSplitter[K]

    Creates an iterator for all keys.

    Creates an iterator for all keys.

    returns

      an iterator over all keys.

    Definition Classes
      ParMapLike → GenMapLike

73. #### def last: (K, V)

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the parallel iterable is empty.

74. #### def lastOption: Option[(K, V)]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this parallel iterable$ if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike

75. #### def map[B](f: (A) ⇒ B): ParMap[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel map .

    [use case]

    Builds a new collection by applying a function to all elements of this parallel map .

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new parallel map resulting from applying the given function `f` to each element of this parallel map and collecting the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def map[S, That](f: ((K, V)) ⇒ S)(implicit bf: CanBuildFrom[ParMap[K, V], S, That]): That

76. #### def mapCompanion: GenericParMapCompanion[ParMap]

    Definition Classes
      ParMap → ParMap → GenericParMapTemplate

77. #### def mapValues[S](f: (V) ⇒ S): parallel.ParMap[K, S]

    Transforms this map by applying a function to every retrieved value.

    Transforms this map by applying a function to every retrieved value.

    f

      the function used to transform values of this map.

    returns

      a map view which maps every key of this map to `f(this(key))`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      ParMapLike → GenMapLike

78. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this parallel map .

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def max[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

79. #### def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this parallel map with the largest value measured by function f.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def maxBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

80. #### def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this parallel map

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def min[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

81. #### def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this parallel map with the smallest value measured by function f.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def minBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

82. #### def mkString: String

    Displays all elements of this parallel iterable in a string.

    Displays all elements of this parallel iterable in a string.

    returns

      a string representation of this parallel iterable. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce

83. #### def mkString(sep: String): String

    Displays all elements of this parallel iterable in a string using a separator string.

    Displays all elements of this parallel iterable in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this parallel iterable. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

84. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this parallel iterable in a string using start, end, and separator strings.

    Displays all elements of this parallel iterable in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this parallel iterable. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this parallel iterable are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

85. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

86. #### def newBuilder: Builder[(K, V), ParIterable[(K, V)]]

    The builder that builds instances of type Traversable[A]

    The builder that builds instances of type Traversable[A]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → GenericTraversableTemplate → HasNewBuilder

87. #### def newCombiner: Combiner[(K, V), ParMap[K, V]]

    Attributes
      protected[this]
    Definition Classes
      GenericParMapTemplate → GenericParTemplate → HasNewCombiner

88. #### def nonEmpty: Boolean

    Tests whether the parallel iterable is not empty.

    Tests whether the parallel iterable is not empty.

    returns

      `true` if the parallel iterable contains at least one element, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

89. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

90. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

91. #### def par: ParMap[K, V]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      ParIterableLike → CustomParallelizable → Parallelizable

92. #### def parCombiner: Combiner[(K, V), ParMap[K, V]]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      CustomParallelizable → Parallelizable

93. #### def partition(pred: ((K, V)) ⇒ Boolean): (ParMap[K, V], ParMap[K, V])

    Partitions this parallel iterable in two parallel iterables according to a predicate.

    Partitions this parallel iterable in two parallel iterables according to a predicate.

    pred

      the predicate on which to partition.

    returns

      a pair of parallel iterables: the first parallel iterable consists of all elements that satisfy the predicate `p` and the second parallel iterable consists of all elements that don't. The relative order of the elements in the resulting parallel iterables may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

94. #### def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this parallel map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the parallel map and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def product[U >: (K, V)](implicit num: Numeric[U]): U

95. #### def reduce[U >: (K, V)](op: (U, U) ⇒ U): U

    Reduces the elements of this sequence using the specified associative binary operator.

    Reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this parallel iterable is empty.

96. #### def reduceLeft[U >: (K, V)](op: (U, (K, V)) ⇒ U): U

    Definition Classes
      ParIterableLike

97. #### def reduceLeftOption[U >: (K, V)](op: (U, (K, V)) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this parallel iterable, going left to right.

    Optionally applies a binary operator to all elements of this parallel iterable, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` if this parallel iterable is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

98. #### def reduceOption[U >: (K, V)](op: (U, U) ⇒ U): Option[U]

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

99. #### def reduceRight[U >: (K, V)](op: ((K, V), U) ⇒ U): U

    Applies a binary operator to all elements of this parallel iterable, going right to left.

    Applies a binary operator to all elements of this parallel iterable, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel iterable, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this parallel iterable.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this parallel iterable is empty.

100. #### def reduceRightOption[U >: (K, V)](op: ((K, V), U) ⇒ U): Option[U]

     Optionally applies a binary operator to all elements of this parallel iterable, going right to left.

     Optionally applies a binary operator to all elements of this parallel iterable, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` if this parallel iterable is nonempty, `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

101. #### def repr: ParMap[K, V]

     Definition Classes
       ParIterableLike → GenTraversableLike

102. #### def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

     Optionally reuses an existing combiner for better performance.

     Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

     oldc

       The combiner that is the result of the previous task, or `None` if there was no previous task.

     newc

       The new, empty combiner that can be used.

     returns

       Either `newc` or `oldc`.

     Attributes
       protected
     Definition Classes
       ParIterableLike

103. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this parallel map .

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this parallel map .

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Note: will not terminate for infinite-sized collections.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def sameElements[U >: (K, V)](that: GenIterable[U]): Boolean

104. #### def scan(z: (K, V))(op: ((K, V), (K, V)) ⇒ (K, V)): ParMap[(K, V)]

     [use case] Computes a prefix scan of the elements of the collection.

     [use case]

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     returns

       a new parallel map containing the prefix scan of the elements in this parallel map

     Definition Classes
       ParIterableLike → GenTraversableLike
     Full Signature

     #### def scan[U >: (K, V), That](z: U)(op: (U, U) ⇒ U)(implicit bf: CanBuildFrom[ParMap[K, V], U, That]): That

105. #### def scanBlockSize: Int

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

106. #### def scanLeft[S, That](z: S)(op: (S, (K, V)) ⇒ S)(implicit bf: CanBuildFrom[ParMap[K, V], S, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

107. #### def scanRight[S, That](z: S)(op: ((K, V), S) ⇒ S)(implicit bf: CanBuildFrom[ParMap[K, V], S, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

108. #### def seq: immutable.Map[K, V]

     Definition Classes
       WithDefault → ParIterableLike → GenMap → GenIterable → GenTraversable → GenMapLike → Parallelizable → GenTraversableOnce

109. #### def sequentially[S, That <: Parallel](b: (immutable.Map[K, V]) ⇒ Parallelizable[S, That]): ParMap[K, V]

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

110. #### def size: Int

     The size of this parallel map .

     The size of this parallel map .

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this parallel map .

     Definition Classes
       WithDefault → GenTraversableLike → GenTraversableOnce

111. #### def slice(unc_from: Int, unc_until: Int): ParMap[K, V]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     unc_from

       the lowest index to include from this parallel iterable.

     unc_until

       the lowest index to EXCLUDE from this parallel iterable.

     returns

       a parallel iterable containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableLike

112. #### def span(pred: ((K, V)) ⇒ Boolean): (ParMap[K, V], ParMap[K, V])

     Splits this parallel iterable into a prefix/suffix pair according to a predicate.

     Splits this parallel iterable into a prefix/suffix pair according to a predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

     Definition Classes
       ParIterableLike → GenTraversableLike

113. #### def splitAt(n: Int): (ParMap[K, V], ParMap[K, V])

     Splits this parallel iterable into two at a given position.

     Splits this parallel iterable into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of parallel iterables consisting of the first `n` elements of this parallel iterable, and the other elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

114. #### def splitter: IterableSplitter[(K, V)]

     Creates a new parallel iterator used to traverse the elements of this parallel collection.

     Creates a new parallel iterator used to traverse the elements of this parallel collection. This iterator is more specific than the iterator of the returned by `iterator`, and augmented with additional accessor and transformer methods.

     returns

       a parallel iterator

     Definition Classes
       WithDefault → ParIterableLike

115. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this parallel map . By default the string prefix is the simple name of the collection class parallel map .

     Definition Classes
       ParMap → ParMap → ParIterable → GenTraversableLike

116. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this parallel map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the parallel map and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def sum[U >: (K, V)](implicit num: Numeric[U]): U

117. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

118. #### def tail: ParMap[K, V]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a parallel iterable consisting of all elements of this parallel iterable except the first one.

     Definition Classes
       ParIterableLike → GenTraversableLike
     Exceptions thrown

       `UnsupportedOperationException` if the parallel iterable is empty.

119. #### def take(n: Int): ParMap[K, V]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take from this parallel iterable.

     returns

       a parallel iterable consisting only of the first `n` elements of this parallel iterable, or else the whole parallel iterable, if it has less than `n` elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

120. #### def takeWhile(pred: ((K, V)) ⇒ Boolean): ParMap[K, V]

     Takes the longest prefix of elements that satisfy the predicate.

     Takes the longest prefix of elements that satisfy the predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       the longest prefix of this parallel iterable of elements that satisfy the predicate `pred`

     Definition Classes
       ParIterableLike → GenTraversableLike

121. #### implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]

     Attributes
       protected
     Definition Classes
       ParIterableLike

122. #### def tasksupport: TaskSupport

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

123. #### def tasksupport_=(ts: TaskSupport): Unit

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     A task support object can be changed in a parallel collection after it has been created, but only during a quiescent period, i.e. while there are no concurrent invocations to parallel collection methods.

     Here is a way to change the task support of a parallel collection:

         import scala.collection.parallel._
         val pc = mutable.ParArray(1, 2, 3)
         pc.tasksupport = new ForkJoinTaskSupport(
           new scala.concurrent.forkjoin.ForkJoinPool(2))

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

124. #### def to[Col[_]]: Col[A]

     [use case] Converts this parallel map into another by copying all elements.

     [use case]

     Converts this parallel map into another by copying all elements.

     Note: will not terminate for infinite-sized collections.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this parallel map .

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, (K, V), Col[(K, V)]]): Col[(K, V)]

125. #### def toArray: Array[A]

     [use case] Converts this parallel map to an array.

     [use case]

     Converts this parallel map to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this parallel map . An `ClassTag` must be available for the element type of this parallel map .

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def toArray[U >: (K, V)](implicit arg0: ClassTag[U]): Array[U]

126. #### def toBuffer[U >: (K, V)]: Buffer[U]

     Uses the contents of this parallel iterable to create a new mutable buffer.

     Uses the contents of this parallel iterable to create a new mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

127. #### def toIndexedSeq: immutable.IndexedSeq[(K, V)]

     Converts this parallel iterable to an indexed sequence.

     Converts this parallel iterable to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

128. #### def toIterable: ParIterable[(K, V)]

     Converts this parallel iterable to an iterable collection.

     Converts this parallel iterable to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this parallel iterable.

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

129. #### def toIterator: scala.Iterator[(K, V)]

     Returns an Iterator over the elements in this parallel iterable.

     Returns an Iterator over the elements in this parallel iterable. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

130. #### def toList: List[(K, V)]

     Converts this parallel iterable to a list.

     Converts this parallel iterable to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

131. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this parallel map to a map.

     [use case]

     Converts this parallel map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this parallel map .

     Definition Classes
       ParMap → ParIterableLike → GenTraversableOnce
     Full Signature

     #### def toMap[P, Q](implicit ev: <:<[(K, V), (P, Q)]): ParMap[P, Q]

132. #### def toParArray: ParArray[T]

     Implicit information
       This member is added by an implicit conversion from WithDefault[K, V] to CollectionsHaveToParArray[WithDefault[K, V], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (WithDefault[K, V]) ⇒ GenTraversableOnce[T] is in scope.
     Definition Classes
       CollectionsHaveToParArray

133. #### def toParCollection[U >: (K, V), That](cbf: () ⇒ Combiner[U, That]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

134. #### def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[(K, V), (K, V)]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

135. #### def toSeq: ParSeq[(K, V)]

     Converts this parallel iterable to a sequence.

     Converts this parallel iterable to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this parallel iterable.

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

136. #### def toSet[U >: (K, V)]: ParSet[U]

     Converts this parallel iterable to a set.

     Converts this parallel iterable to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

137. #### def toStream: Stream[(K, V)]

     Converts this parallel iterable to a stream.

     Converts this parallel iterable to a stream.

     returns

       a stream containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

138. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParIterableLike → AnyRef → Any

139. #### def toTraversable: GenTraversable[(K, V)]

     Converts this parallel iterable to an unspecified Traversable.

     Converts this parallel iterable to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

140. #### def toVector: Vector[(K, V)]

     Converts this parallel iterable to a Vector.

     Converts this parallel iterable to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this parallel iterable.

     Definition Classes
       ParIterableLike → GenTraversableOnce

141. #### def transpose[B](implicit asTraversable: ((K, V)) ⇒ GenTraversableOnce[B]): ParIterable[ParIterable[B]]

     Transposes this collection of traversable collections into a collection of collections.

     Transposes this collection of traversable collections into a collection of collections.

     The resulting collection's type will be guided by the static type of collection. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this collection is a `Traversable`.

     returns

       a two-dimensional collection of collections which has as nth row the nth column of this collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown

       `IllegalArgumentException` if all collections in this collection are not of the same size.

142. #### def unzip[A1, A2](implicit asPair: ((K, V)) ⇒ (A1, A2)): (ParIterable[A1], ParIterable[A2])

     Converts this collection of pairs into two collections of the first and second half of each pair.

     Converts this collection of pairs into two collections of the first and second half of each pair.

         val xs = Traversable(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this collection is a pair.

     returns

       a pair of collections, containing the first, respectively second half of each element pair of this collection.

     Definition Classes
       GenericTraversableTemplate

143. #### def unzip3[A1, A2, A3](implicit asTriple: ((K, V)) ⇒ (A1, A2, A3)): (ParIterable[A1], ParIterable[A2], ParIterable[A3])

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

         val xs = Traversable(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three),
         //        Traversable(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this collection is a triple.

     returns

       a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

     Definition Classes
       GenericTraversableTemplate

144. #### def updated[U >: V](key: K, value: U): WithDefault[K, U]

     Definition Classes
       WithDefault → ParMap → ParMap → GenMap

145. #### def values: parallel.ParIterable[V]

     Collects all values of this map in an iterable collection.

     Collects all values of this map in an iterable collection.

     returns

       the values of this map as an iterable.

     Definition Classes
       ParMapLike → GenMapLike

146. #### def valuesIterator: IterableSplitter[V]

     Creates an iterator for all values in this map.

     Creates an iterator for all values in this map.

     returns

       an iterator over all values that are associated with some key in this map.

     Definition Classes
       ParMapLike → GenMapLike

147. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

148. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

149. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

150. #### def withDefault[U >: V](d: (K) ⇒ U): ParMap[K, U]

     The same map with a given default function.

     The same map with a given default function. Note: `get`, `contains`, `iterator`, `keys`, etc are not affected by `withDefault`.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       the function mapping keys to values, used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       WithDefault → ParMap

151. #### def withDefaultValue[U >: V](d: U): ParMap[K, U]

     The same map with a given default value.

     The same map with a given default value.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       default value used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       WithDefault → ParMap

152. #### def withFilter(pred: ((K, V)) ⇒ Boolean): ParMap[K, V]

     Definition Classes
       ParIterableLike

153. #### def wrap[R](body: ⇒ R): NonDivisible[R]

     Attributes
       protected
     Definition Classes
       ParIterableLike

154. #### def zip[B](that: GenIterable[B]): ParMap[(A, B)]

     [use case] Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new parallel map containing pairs consisting of corresponding elements of this parallel map and `that`. The length of the returned collection is the minimum of the lengths of this parallel map and `that`.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def zip[U >: (K, V), S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[ParMap[K, V], (U, S), That]): That

155. #### def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): ParMap[(A, B)]

     [use case] Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel map formed from this parallel map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this parallel map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this parallel map .

     returns

       a new parallel map containing pairs consisting of corresponding elements of this parallel map and `that`. The length of the returned collection is the maximum of the lengths of this parallel map and `that`. If this parallel map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this parallel map , `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def zipAll[S, U >: (K, V), That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[ParMap[K, V], (U, S), That]): That

156. #### def zipWithIndex: ParMap[(A, Int)]

     [use case] Zips this parallel map with its indices.

     [use case]

     Zips this parallel map with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       A new parallel map containing pairs consisting of all elements of this parallel map paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[U >: (K, V), That](implicit bf: CanBuildFrom[ParMap[K, V], (U, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

157. #### def →[B](y: B): (WithDefault[K, V], B)

     Implicit information
       This member is added by an implicit conversion from WithDefault[K, V] to ArrowAssoc[WithDefault[K, V]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from WithDefault[K, V] to any2stringadd[WithDefault[K, V]] performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (withDefault: any2stringadd[WithDefault[K, V]]).+(other)

   Definition Classes
     any2stringadd

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

2. #### def view: IterableView[(K, V), immutable.Map[K, V]]

   Definition Classes
     ParIterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use .seq.view instead

### Inherited from ParMap[K, V]

### Inherited from ParIterable[(K, V)]

### Inherited from Immutable

### Inherited from ParMap.WithDefault[K, V]

### Inherited from parallel.ParMap[K, V]

### Inherited from ParMapLike[K, V, ParMap[K, V], immutable.Map[K, V]]

### Inherited from parallel.ParIterable[(K, V)]

### Inherited from ParIterableLike[(K, V), ParMap[K, V], immutable.Map[K, V]]

### Inherited from Parallel

### Inherited from CustomParallelizable[(K, V), ParMap[K, V]]

### Inherited from GenericParMapTemplate[K, V, ParMap]

### Inherited from GenericParTemplate[(K, V), ParIterable]

### Inherited from HasNewCombiner[(K, V), ParMap[K, V]]

### Inherited from GenMap[K, V]

### Inherited from GenIterable[(K, V)]

### Inherited from GenTraversable[(K, V)]

### Inherited from GenericTraversableTemplate[(K, V), ParIterable]

### Inherited from HasNewBuilder[(K, V), scala.collection.parallel.immutable.ParIterable[(K, V)] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from GenMapLike[K, V, ParMap[K, V]]

### Inherited from Equals

### Inherited from GenIterableLike[(K, V), ParMap[K, V]]

### Inherited from GenTraversableLike[(K, V), ParMap[K, V]]

### Inherited from Parallelizable[(K, V), ParMap[K, V]]

### Inherited from GenTraversableOnce[(K, V)]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from WithDefault[K, V] to CollectionsHaveToParArray[WithDefault[K, V], T]

### Inherited by implicit conversion any2stringadd from WithDefault[K, V] to any2stringadd[WithDefault[K, V]]

### Inherited by implicit conversion StringFormat from WithDefault[K, V] to StringFormat[WithDefault[K, V]]

### Inherited by implicit conversion Ensuring from WithDefault[K, V] to Ensuring[WithDefault[K, V]]

### Inherited by implicit conversion ArrowAssoc from WithDefault[K, V] to ArrowAssoc[WithDefault[K, V]]

### Ungrouped